Page MenuHomePhabricator

Add addtional hints you haven't submitted comments on a Diff
ClosedPublic

Authored by chad on Nov 5 2014, 6:00 PM.
Tags
None
Referenced Files
F11402989: D10789.id25888.diff
Wed, Nov 30, 3:10 AM
F11402987: D10789.id26271.diff
Wed, Nov 30, 3:10 AM
F11402986: D10789.id26068.diff
Wed, Nov 30, 3:10 AM
F11402983: D10789.id.diff
Wed, Nov 30, 3:09 AM
F11402982: D10789.id26270.diff
Wed, Nov 30, 3:09 AM
Unknown Object (File)
Mon, Nov 28, 8:12 PM
Unknown Object (File)
Wed, Nov 16, 10:41 AM
Unknown Object (File)
Wed, Nov 9, 2:15 AM
Subscribers

Details

Summary

Ref T3669. Probably. Adds a yellow warning at the top of the Diff View and makes the comment draft icon yellow on lists of revisions.

Test Plan

Test a diff with many warnings, see warning. Test a diff with draft comments, see warning. Test new icon in list view.

pasted_file (134×463 px, 29 KB)

pasted_file (168×358 px, 36 KB)

Diff Detail

Repository
rP Phabricator
Branch
draft-comments
Lint
Lint Passed
Unit
Tests Passed
Build Status
Buildable 2952
Build 2956: [Placeholder Plan] Wait for 30 Seconds

Event Timeline

chad retitled this revision from to Add addtional hints you haven't submitted comments on a Diff.
chad updated this object.
chad edited the test plan for this revision. (Show Details)
chad added reviewers: epriestley, btrahan.

I don't think this will help very much. It doesn't address the fundamental issue of coming into things with the GitHub model and being surprised by the Phabricator model, because you're unlikely to scroll to the top of the revision after leaving a comment.

How about a persistent notification bubble? Did we discuss and dismiss that already?

Honestly, if this is all Reviewboard does, I think it's likely useful and it does make it more clear (that is, I find it a useful reminder). Whether people will still want more, it's hard to say. I'm fine keeping the ticket open.

chad edited edge metadata.

What's the notification bubble idea? A one-time NUX thing for when you don't submit, or something that follows you everywhere? I have tons of drafts, I assume you do too.

ReviewBoard has a persistent, floating, fixed-position header, not just a banner at the top of the page.

Screen_Shot_2014-11-05_at_10.21.52_AM.png (1×1 px, 201 KB)

Bubble would be something like this in the lower left (like notification bubbles, but persistent):

/-------------------------------\
| Unsubmitted Comments           |
| You have draft inline comments |
| you have not submitted yet.    |
\-------------------------------/

It would show up only when the current page had unsubmitted drafts. Basically like Review Board's thing, but a notification bubble instead of a giant banner.

My concern with a persistent header or floating bubble is that says, basically, we know our system is broken and thus will remind you all the time regardless of if you actually need it. It seems like a feature that would get in the way of the pro-users, which we philosophically engineer the product towards. I could be wrong, I'd be happy to test it, but it seems very heavy.

I do think our system is 'more correct' than Github, and a light touch with reminders/warnings we don't interrupt anyone and educate the new people

(Is there an easy way for me to spin up a notification on page load?)

Yeah, I don't like it either. I think the alternatives are that + an option to turn it off (also bad), that + some kind of one-time-mode (still bad, really hard to test), or not fixing this.

It's probably involved to show/hide the notification correctly -- if you add an inline we have to show it (and this is by far the most important time to show it, I think -- if users make it back to the page later, it's probably because they realized their thing didn't submit -- we need to tell you right after you create the inline), and we should remove it if you delete all the pending inlines, so it needs to be JS-based rather than just checking if drafts exist.

Overall, my inclination is to punt until after T1460 and examine something on the inlines themselves when they get retouched for that. For example, a yellow "draft" banner on the inline might do a better job than just the dashed border and grey "Draft" text.

(I also think the list change is fine on its own if you want to do that, but that it won't move the needle on T3669 much.)

I do think it's useful for everyone, and if it helps a few new people, bonus. ✔

Another report came in today and I merged it into the master task.

Did we talk about yelling when you try to leave the page yet? Basically if there's an unsubmitted inline comment we can raise one of those javascrpt "you have unsubmitted ish are you sure?" type dialogues.

src/applications/differential/controller/DifferentialRevisionViewController.php
967

you could just grab the user with $this->getRequest()->getUser() if you like... 5 parameters is a bunch.

Some discussion of that in the attached task. A major issue is that we have very limited ability to tell the user why we're yelling at them in some browsers (Firefox, IIRC).

src/applications/differential/controller/DifferentialRevisionViewController.php
967

You can even do $this->getViewer() now on Controllers.

This is the Firefox issue, specifically:T3669#48974

chad edited edge metadata.
  • Simplify
epriestley edited edge metadata.

My concern is that I'm like 99% sure this won't help at all (users who this affects will never see the warning because they'll scroll down, make a comment, think it submitted, and not open the revision again until it's too late). If you want to pursue this anyway that's fine, but I intend to revert it after addressing this more directly (during T1460).

This revision is now accepted and ready to land.Dec 3 2014, 11:45 AM

I think solves a different problem that we currently have, regardless. It provides a consistent, more obvious indication that you have drafts somewhere on the current page. Are there plans for similar in T1460? Though my memory is pretty terrible according to my wife, so features like this may be more useful than the average to me.

I not sure any users have the other problem (understanding how draft inlines work, but forgetting they have left unsubmitted draft inlines, despite returning to the revision later). Have you experienced this, or seen reports of it? I don't recall anyone raising that issue in T3669.

I don't have plans to solve that problem because I don't currently believe users experience it: either they don't understand the model (and will thus never see the warning) or (rarely) they forget about inlines completely and don't return to the revision (and again never see the warning).

I think the change to the status list is worth keeping regardless (and has a far better chance of being useful, since users don't need to return to the revision in order to see it), but am very wary about cluttering the page header with high-attention, low-value information.

chad edited edge metadata.
  • Simplify
  • Remove contentious thingys
This revision was automatically updated to reflect the committed changes.